/*
 * ̔F
 */

#include "executeOPE.h"

#define DEBUG

extern EstimateParameter vest_param;
extern int correspondence_of_vestp;

bool calibrationFlag;

extern int re_estimate;

int getObjectPoseExecute(const int id, const CvPoint3D32f PointCloud[25344], std::vector<Model> &ObjectModelList, 
						 std::vector<EstimateParameter>& FinalEstimateResultList, std::vector<std::vector<CvPoint3D32f>>& FinalResultVertexList)
{
	printf("getObjectPose");

	//̗̈_Q}XNpz錾Ɨ̈m
	unsigned int **ObjectsMask;
	ObjectsMask = BNew(unsigned int, HEIGHT_VALUE, WIDTH_VALUE);

	//xOpvector
	std::vector<int> ObjectsLabel;

	//C[t[摜̂߂vector
	std::vector<std::vector<CvPoint3D32f>> sum_result_points;

	//f̎ނ
	int ObjectCategory;

	printf("getObjectModel_Success\n");

	int ind = 0;

	int zero_count = 0;

	//̓_Q擾
	for(int h = 0; h < HEIGHT_VALUE; h++)
	{
		for(int w = 0; w < WIDTH_VALUE; w++)
		{
			if(h == 0 && w == 0)
				zero_count = 0;

			ind = h * WIDTH_VALUE + w;

			RangeDatalist[ind].x = PointCloud[ind].x;
			RangeDatalist[ind].y = PointCloud[ind].y;
			RangeDatalist[ind].z = PointCloud[ind].z;

			if(RangeDatalist[ind].z < 0.01)
				zero_count++;

		}
	}	
	if(zero_count > 3000)
	{
		printf("re_estimate\n");
		re_estimate = 1;
		return 1;
	}


	printf("get newRangeDatalist\n");
		
	//܂C̓̕_QƁCxO摜𓾂D
	if(!ObjectsLabel.empty())
	{
		ObjectsLabel.clear();
	}

	if(!FindVarietyObjects_with_plane(ObjectsMask, &ObjectsLabel))
	{
		printf("Could not find object\n");

		for(int i = 0; i < HEIGHT_VALUE; i++)
		{
			free(ObjectsMask[i]);
		}
		free(ObjectsMask);

		return 1;
	}

	int ObjectType;

	//ê̌
	box_count = cylinder_count = 0;

	obj_count = 0;
	
	for(int i = 0; i < large_region_num; i++)
	{
		printf("ObjectsLabel[%d]:%d\n",i,ObjectsLabel[i]);
	}

	int box_count, cylinder_count;


	std::vector<EstimateParameter> EstimateResultList(large_region_num);
	std::vector<std::vector<CvPoint3D32f>> ResultVertexList;
	ResultVertexList.resize(large_region_num);

	std::vector<CvPoint3D32f> ResultVertex;

	//20120203 ADD S̒T[hpꎞʕۑXg
	//͎Ă郂f̌

	std::vector<EstimateParameter> TempList_DifferentModel(ObjectModelList.size());
	std::vector<std::vector<CvPoint3D32f>> TempVList_DifferentModel;
	TempVList_DifferentModel.resize(ObjectModelList.size());


	//ŏIʗpʃXgCʕ`p_Xǧݒ
	FinalEstimateResultList.resize(large_region_num);
	FinalResultVertexList.resize(large_region_num);


	printf("\n");


	printf("ObjectModelList.size() = %d\n",ObjectModelList.size());

	//̂large_region_numƂē̂ŁĈԂ񂾂JԂ
	//w肳ꂽID̃fƂꂼ̓̕_QƂ̊ԂICP
	for(int i = 0; i < large_region_num; i++)
	{
		for(int objcount = 0; objcount < ObjectModelList.size(); objcount++)
		{
			printf("objcount : %d\n",objcount);

			//肷镨̂̎ނ擾
			ObjectCategory = ObjectModelList[objcount].Model_category;

			printf("ObjectCategory %d\n",ObjectCategory);

			//ObjectTypéCgȂD@20111124
			ObjectType = CalcObjectUpperSurface(i, ObjectsMask, ObjectsLabel);
			printf("ObjectType:%d id : %d",ObjectType,id);

			//ʒup
			//̂̏ꍇ
			if(ObjectCategory == 0)
			{				
				
				BoxWX = ObjectModelList[objcount].wx;
				BoxWY = ObjectModelList[objcount].wy;
				BoxWZ = ObjectModelList[objcount].wz;

				int BoxPattern = BOX_XY;

				std::vector<EstimateParameter> TempResultList(3);
				std::vector<std::vector<CvPoint3D32f>> final_vertex_list;
				final_vertex_list.resize(3);

				//̂̒u3p^[ׂēĂ͂߂
				for(int j = 0; j < 3; j++)
				{
					LocateObject(BoxPattern+j);
					TempResultList[j].id = ObjectModelList[objcount].Model_id;
					//I̊eʂƂ̋̒ŁCő̂̂i[
					TempResultList[j].estimate_error = vest_param.estimate_error;
					//ł悩Ƃ̑Ή_i[
					TempResultList[j].effective_points = correspondence_of_vestp;

					TempResultList[j].pose.position.x = object_pose.x;
					TempResultList[j].pose.position.y = object_pose.y;
					TempResultList[j].pose.position.z = object_pose.z;
					TempResultList[j].pose.orientation.r = object_pose.tx;
					TempResultList[j].pose.orientation.p = object_pose.ty;
					TempResultList[j].pose.orientation.y = object_pose.tz;

					TempResultList[j].evaluate_value = vest_param.evaluate_value;

					final_vertex_list[j].resize(8);

					for(int k = 0; k < 8; k++)
					{
						final_vertex_list[j][k].x = final_vertices_x[k];
						final_vertex_list[j][k].y = final_vertices_y[k];
						final_vertex_list[j][k].z = final_vertices_z[k];
					}
#ifdef DEBUG
				printf("estimate_error:%6.6f\n",TempResultList[j].estimate_error);
				printf("effective_points:%d\n",TempResultList[j].effective_points);


				printf("vest_param.estimate_error = %.3f\n",vest_param.estimate_error);
				printf("VEST object_pose = (%.3f, %.3f, %.3f, %.3f, %.3f, %.3f)\n"
					,object_pose.x ,object_pose.y ,object_pose.z
					,object_pose.tx ,object_pose.ty ,object_pose.tz);
				printf("-------------------------------------------\n");
				printf("vest_param.evaluate_value = %f\n",vest_param.evaluate_value);
				printf("-------------------------------------------\n");
#endif
				}
				//3p^[łfʂ̏dSƃfʂɓef[^_dS߂̂I
				double TempMinEvaluateValue = VERY_LARGE;
				int TempOutputNum;
				for(int j = 0; j < 3; j++)
				{
					if(TempMinEvaluateValue > TempResultList[j].evaluate_value)
					{
						TempOutputNum = j;
						TempMinEvaluateValue = TempResultList[j].evaluate_value;
					}
				}
#ifdef DEBUG
			printf("TempOutputNum:%d\n",TempOutputNum);
			printf("-----------------------------------------------\n");
			printf("TempMinEvaluateValue:%f\n",TempMinEvaluateValue);
			printf("-----------------------------------------------\n");
#endif
				EstimateResultList[i] = TempResultList[TempOutputNum];
				//I񂾂Ƃ̌ʂobject_poseɂ
				object_pose.x = TempResultList[TempOutputNum].pose.position.x;
				object_pose.y = TempResultList[TempOutputNum].pose.position.y;
				object_pose.z = TempResultList[TempOutputNum].pose.position.z;
				object_pose.tx = TempResultList[TempOutputNum].pose.orientation.r;
				object_pose.ty = TempResultList[TempOutputNum].pose.orientation.p;
				object_pose.tz = TempResultList[TempOutputNum].pose.orientation.y;

				//lɌʕ`p_Xgۑ
				ResultVertex.resize(8);
				ResultVertex = final_vertex_list[TempOutputNum];

			}
			else if(ObjectCategory == 1)
			{
				CylinderHeight = ObjectModelList[objcount].height;
				CylinderRadius = ObjectModelList[objcount].radius;

				LocateObject(ObjectCategory);
				EstimateResultList[i].id = ObjectModelList[objcount].Model_id;
				//TODO:SΉ_Cʂ̑Ή_̊i[
				EstimateResultList[i].estimate_error = vest_param.estimate_error;
				//ł悩Ƃ̑Ή_i[
				EstimateResultList[i].effective_points = correspondence_of_vestp;

				EstimateResultList[i].side_correspondence_rate = vest_param.side_correspondence_rate;
#ifdef DEBUG
			printf("estimate_error:%6.6f\n",EstimateResultList[i].estimate_error);
			printf("effective_points:%d\n",EstimateResultList[i].effective_points);
			printf("vest_side_correspondence_rate:%.6f\n",EstimateResultList[i].side_correspondence_rate);

			printf("vest_param.estimate_error = %.3f\n",vest_param.estimate_error);
			printf("VEST object_pose = (%.3f, %.3f, %.3f, %.3f, %.3f, %.3f)\n"
				,object_pose.x ,object_pose.y ,object_pose.z
				,object_pose.tx ,object_pose.ty ,object_pose.tz);
#endif		

			}

			//Op[^̃t@C΍Wϊ
			FILE *fp, *fp2;

			if((fp = fopen("Rotation.xml", "r")) != NULL && (fp2 = fopen("Translation.xml", "r")) != NULL )
			{
				fclose(fp);
				fclose(fp2);
				TransData();			
			}
			else
			{
				//IFɒPʂ킹
				object_pose.x = object_pose.x * 1000.0;
				object_pose.y = object_pose.y * 1000.0;
				object_pose.z = object_pose.z * 1000.0;
			}

			EstimateResultList[i].pose.position.x = object_pose.x;
			EstimateResultList[i].pose.position.y = object_pose.y;
			EstimateResultList[i].pose.position.z = object_pose.z;

			EstimateResultList[i].pose.orientation.r = object_pose.tx;
			EstimateResultList[i].pose.orientation.p = object_pose.ty;
			EstimateResultList[i].pose.orientation.y = object_pose.tz;


			//20120203 ADD
			//ST[hpXgɒǉ
			TempList_DifferentModel[objcount] = EstimateResultList[i];

			//C[t[\͍ŏIʂ݂̂ɕύX@20111124
			if(ObjectCategory == 0)
			{
				ResultVertexList[i].resize(8);

				for(int j = 0; j < 8; j++)
				{
					ResultVertexList[i][j].x = ResultVertex[j].x;
					ResultVertexList[i][j].y = ResultVertex[j].y;
					ResultVertexList[i][j].z = ResultVertex[j].z;

#ifdef DEBUG
				printf("ObjectCount:%d\n",i);
				printf("[%d] %f %f %f\n",j ,ResultVertex[j].x, ResultVertex[j].y, ResultVertex[j].z);
#endif
				}

				TempVList_DifferentModel[objcount] = ResultVertexList[i];

			}
			else
			{
				ResultVertex.resize(16);
				ResultVertexList[i].resize(16);

				for(int j = 0; j < 16; j++)
				{
					ResultVertex[j].x = final_cylinder_vertices_x[j];
					ResultVertex[j].y = final_cylinder_vertices_y[j];
					ResultVertex[j].z = final_cylinder_vertices_z[j];

					ResultVertexList[i][j].x = ResultVertex[j].x;
					ResultVertexList[i][j].y = ResultVertex[j].y;
					ResultVertexList[i][j].z = ResultVertex[j].z;

#ifdef DEBUG
				printf("ObjectCount:%d\n",i);
				printf("[%d] %f %f %f\n",j ,ResultVertex[j].x, ResultVertex[j].y, ResultVertex[j].z);
#endif
				}

				TempVList_DifferentModel[objcount] = ResultVertexList[i];
			}	
		}

		int selected;

		//ǂ̐茋ʂc
		for(int c = 0; c < ObjectModelList.size(); c++)
		{
			fprintf(stderr, "objcount : %d, side_correspondence_rate : %f, evaluate_value : %f, effective_points : %d"
				,c, TempList_DifferentModel[c].side_correspondence_rate
				,TempList_DifferentModel[c].evaluate_value
				,TempList_DifferentModel[c].effective_points);

			if(TempList_DifferentModel[c].side_correspondence_rate > 0.6)
			{
				FinalEstimateResultList[i] = TempList_DifferentModel[c];
				FinalResultVertexList[i] = TempVList_DifferentModel[c];
				selected = c;
				break;
			}
			else
			{
				if(TempList_DifferentModel[c].effective_points > 400)
				{
					FinalEstimateResultList[i] = TempList_DifferentModel[c];
					FinalResultVertexList[i] = TempVList_DifferentModel[c];
					selected = c;
					break;
				}
			}
		}
		fprintf(stderr, "selected : %d\n",selected);

	}

	if(ObjectModelList.size() == 1)
	{

		int OutputNum = 0;

		if(ObjectCategory == 0)
		{
			//̃fĂꍇFfƃf[^_Qꂼ̏dS̋߂̗̂p
			double MinEvaluateValue = VERY_LARGE;

			for(int i = 0; i < EstimateResultList.size(); i++)
			{
				if(MinEvaluateValue > EstimateResultList[i].evaluate_value)
				{
					OutputNum = i;
					MinEvaluateValue = EstimateResultList[i].evaluate_value;
				}
			}
		}
		else if(ObjectCategory == 1)
		{
			//~fĂꍇFʂ̓_Q̂ȂŁCΉ_̗̊̂p
			double MaxCorrespondenceRate = VERY_SMALL;

			for(int i = 0; i < EstimateResultList.size(); i++)
			{
				if(MaxCorrespondenceRate < EstimateResultList[i].side_correspondence_rate)
				{
					OutputNum = i;
					MaxCorrespondenceRate = EstimateResultList[i].side_correspondence_rate;
				}
			}
		}

		FinalEstimateResultList[0] = EstimateResultList[OutputNum];
		FinalResultVertexList[0] = ResultVertexList[OutputNum];
	}

	//J

	if(ObjectsMask != NULL)
	{
		for(int i = 0; i < HEIGHT_VALUE; i++)
		{
			free(ObjectsMask[i]);
		}
		free(ObjectsMask);
	}

  return 0;
}
